﻿using System.Collections.ObjectModel;

using CommunityToolkit.Maui.Core;

namespace TestProject;

/// <summary>
/// 메인 페이지
/// </summary>
public partial class MainPage : ContentPage
{
    //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
    ////////////////////////////////////////////////////////////////////////////////////////// Public

    #region 생성자 - MainPage()

    /// <summary>
    /// 생성자
    /// </summary>
    public MainPage()
    {
        InitializeComponent();

        this.drawingView.Lines = new ObservableCollection<IDrawingLine>();

        this.drawingView.DrawingLineCompleted += drawingView_DrawingLineCompleted;
    }

    #endregion

    //////////////////////////////////////////////////////////////////////////////////////////////////// Method
    ////////////////////////////////////////////////////////////////////////////////////////// Private

    #region 드로잉 뷰 선 그리기 완료시 처리하기 - drawingView_DrawingLineCompleted(sender, e)

    /// <summary>
    /// 드로잉 뷰 선 그리기 완료시 처리하기
    /// </summary>
    /// <param name="sender">이벤트 발생자</param>
    /// <param name="e">이벤트 인자</param>
    private async void drawingView_DrawingLineCompleted(object sender, DrawingLineCompletedEventArgs e)
    {
        Stream stream = await e.LastDrawingLine.GetImageStream(this.image.Width, this.image.Height, Colors.Gray.AsPaint());

        this.image.Source = ImageSource.FromStream(() => stream);
    }

    #endregion
}